#ifndef BTRACE_H
#define BTRACE_H

#include <stdio.h>
#include <stdbool.h>

#define BTRACE_NONE  0
#define BTRACE_PLAIN 1
#define BTRACE_XML   2
#define BTRACE_JSON  3
#define BTRACE_ERROR 4

void btrace_enable(const char*);
void btrace_disable(void);
void btrace_reset(void);

bool btrace_is_enabled(void);
bool btrace_is_empty(void);
size_t btrace_count(void);

int btrace_format(const char*);
int btrace_print_stream(FILE*, int);
int btrace_print(const char*, int);
void btrace_add(const char* file, int line, const char*, ...);

#define btrace(...) btrace_add(__FILE__, __LINE__, __VA_ARGS__)

#endif
