#ifndef COMMENTS_H
#define COMMENTS_H

#include <stdio.h>
#include <stddef.h>

typedef enum {
  action_none,
  action_retain,
  action_generate,
  action_read
} comments_action_t;

typedef struct
{
  comments_action_t action;
  struct {
    const char *input, *output;
  } path;
} comments_opt_t;

typedef struct comments_t comments_t;

comments_t* comments_new(void);
void comments_destroy(comments_t*);
size_t comments_count(const comments_t*);
int comments_push(comments_t*, const char*);
int comments_each(const comments_t*, int (*)(const char*, void*), void*);
int comments_copy(const comments_t*, comments_t*);
int comments_cat(const comments_t**, size_t, const char*, comments_t*);
int comments_finalise(comments_t*);
int comments_process(comments_t*, const comments_opt_t*);


#endif
